Subject: TagBuilder is not resetted when a view helper is initialized multiple times
Description

Since r2895 ViewHelpers that belong to the same ViewHelperNode (inside loops) are only instantiated once. This leads to the
side-effect, that $this->tag points to the same reference.
If a tag attribute is set it won't be resetted when initialize() is called.

Example:

<f:for each="{0:1, 1:2, 2:3, 3:4}" as="foo">
    <f:link.action class="{f:if('odd' condition='{foo} % 2')}">{foo}</f:link.action>
</f:for>

Expected result:

<a class="odd" href="viewhelpertest/standard">1</a>
<a href="viewhelpertest/standard">2</a>
<a class="odd" href="viewhelpertest/standard">3</a>
<a href="viewhelpertest/standard">4</a>

Actual result:

<a class="odd" href="viewhelpertest/standard">1</a>
<a class="odd" href="viewhelpertest/standard">2</a>
<a class="odd" href="viewhelpertest/standard">3</a>
<a class="odd" href="viewhelpertest/standard">4</a>

Solution:
Reset TagBuilder instance in initialize()

And we should check, whether there are more side-effects!

Related issues:
related to TYPO3.Fluid - Bug # 3994: Viewhelpers are instanciated multiple ti... Resolved 2009-07-27
related to Official Doc Templates - Task # 40511: Add link examples Resolved 2012-09-01

Associated revisions
Revision 6b203075 - 2009-09-03 21:27 - Bastian Waidelich
[+FEATURE] Fluid (ViewHelpers): Added reset() method to TagBuilder. This is called in all TagBasedViewHelper's initialize() method. This resolves
#4051.

History
#1 - 2009-07-29 14:01 - Bastian Waidelich
- File 4051.patch added
- Status changed from New to Needs Feedback
- Assigned To set to Robert Lemke

The attached patch fixes the issue for me.
@Robert: Please have a look and commit if there are no objections

#2 - 2009-07-31 12:05 - Robert Lemke
- Target version set to 1.0.0 alpha 3

#3 - 2009-09-03 20:37 - Bastian Waidelich
- Assigned To changed from Robert Lemke to Bastian Waidelich

#4 - 2009-09-03 22:01 - Bastian Waidelich
- Status changed from Needs Feedback to Resolved
- % Done changed from 0 to 100

Applied in changeset r3119.

#5 - 2009-09-04 11:10 - Robert Lemke
- Target version changed from 1.0.0 alpha 3 to 1.0.0 alpha 4

Files
4051.patch 3.6 kB 2009-07-29 Bastian Waidelich
